SystemOrganization addCategory: #ConfigurationOfOrderPreservingDictionary!

Object subclass: #ConfigurationOfOrderPreservingDictionary
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOrderPreservingDictionary'!

!ConfigurationOfOrderPreservingDictionary commentStamp: '<historical>' prior: 0!
(ConfigurationOfOrderPreservingDictionary project version: #stable) load

(ConfigurationOfOrderPreservingDictionary project version: #stable) load: #('Tests')!

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'private' stamp: 'StephaneDucasse 2/16/2013 20:12'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'private' stamp: 'StephaneDucasse 2/16/2013 20:12'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/16/2013 20:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/16/2013 20:12'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'loading' stamp: 'StephaneDucasse 2/16/2013 20:12'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'loading' stamp: 'StephaneDucasse 2/16/2013 20:12'!
loadDefault
	"self loadDefault"

	^ self loadMostRecentCoreWithTests! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'loading' stamp: 'StephaneDucasse 2/16/2013 20:12'!
loadMostRecentCoreWithTests
	^self project lastVersion load: #('Core' 'Tests')! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/16/2013 20:12'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'accessing' stamp: 'StephaneDucasse 2/16/2013 20:12'!
project

	^self new project! !

!ConfigurationOfOrderPreservingDictionary class methodsFor: 'unloading Metacello' stamp: 'StephaneDucasse 2/16/2013 20:12'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfOrderPreservingDictionary methodsFor: 'baselines' stamp: 'StephaneDucasse 2/16/2013 20:17'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://smalltalkhub.com/mc/Pharo/OrderPreservingDictionary/main'.	
		spec description: 'Imported from SqueakSource'.
		spec package: 'Collections-OrderPreservingDictionary'.
		spec 
			package: 'Collections-Tests-OrderPreservingDictionary' 
			with: [spec requires: 'Collections-OrderPreservingDictionary'].
			
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('Collections-OrderPreservingDictionary');
			group: 'Tests' with: #('Collections-Tests-OrderPreservingDictionary'). ].! !

!ConfigurationOfOrderPreservingDictionary methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 2/16/2013 20:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'
! !

!ConfigurationOfOrderPreservingDictionary methodsFor: 'accessing' stamp: 'StephaneDucasse 2/16/2013 20:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfOrderPreservingDictionary methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 2/16/2013 20:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
	! !

!ConfigurationOfOrderPreservingDictionary methodsFor: 'versions' stamp: 'StephaneDucasse 2/16/2013 20:20'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'Latest versions from Squeaksource'.
		
		spec package: 'Collections-OrderPreservingDictionary' with: 'Collections-OrderPreservingDictionary-JAA.7'.
		spec package: 'Collections-Tests-OrderPreservingDictionary' with: 'Collections-Tests-OrderPreservingDictionary-JAAyer.7'
		]
	

! !
